Package org.eclipse.cdt.core.dom.ast.cpp

# Interface ICPPASTExplicitTemplateInstantiation

All Superinterfaces:
  `IASTDeclaration`, `IASTNode`

All Known Subinterfaces:
  `IGPPASTExplicitTemplateInstantiation`

public interface ICPPASTExplicitTemplateInstantiation extends IASTDeclaration
This interface represents an explicit template instantiation.

Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`EXTERN`
C++0x.
`static final int`
`INLINE`
Gnu extension.
`static final ASTNodeProperty`
`OWNED_DECLARATION`
`OWNED_DECLARATION` represents the role of the inner declaration that this template refers to.
`static final int`
`STATIC`
Gnu extension.

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTDeclaration

`EMPTY_DECLARATION_ARRAY`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

## Method Summary

Modifier and Type
Method
Description
`ICPPASTExplicitTemplateInstantiation`
`copy()`
Returns a mutable copy of the tree rooted at this node.
`ICPPASTExplicitTemplateInstantiation`
`copy(IASTNode.CopyStyle style)`
Returns a mutable copy of the tree rooted at this node.
`IASTDeclaration`
`getDeclaration()`
Get the owned declaration.
`int`
`getModifier()`
Returns `STATIC`, `INLINE`, `EXTERN`, or `0`.
`void`
`setDeclaration(IASTDeclaration declaration)`
Set the owned declaration.
`void`
`setModifier(int value)`
Set the modifier value, not allowed on frozen ast.

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

## Field Details

### STATIC

static final int STATIC
Gnu extension.

Since:
  5.2
See Also:
  - Constant Field Values

### INLINE

static final int INLINE
Gnu extension.

Since:
  5.2
See Also:
  - Constant Field Values

### EXTERN

static final int EXTERN
C++0x.

Since:
  5.2
See Also:
  - Constant Field Values

### OWNED_DECLARATION

static final ASTNodeProperty OWNED_DECLARATION
`OWNED_DECLARATION` represents the role of the inner declaration that this template refers to.

## Method Details

### getDeclaration

IASTDeclaration getDeclaration()
Get the owned declaration.

Returns:
  `IASTDeclaration`

### setDeclaration

void setDeclaration(IASTDeclaration declaration)
Set the owned declaration.

Parameters:
  `declaration` - `IASTDeclaration`

### copy

ICPPASTExplicitTemplateInstantiation copy()
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Calling this method is equivalent to `copy(CopyStyle.withoutLocations)`.

Specified by:
  `copy` in interface `IASTDeclaration`
Specified by:
  `copy` in interface `IASTNode`
Since:
  5.1

### copy

ICPPASTExplicitTemplateInstantiation copy(IASTNode.CopyStyle style)
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Specified by:
  `copy` in interface `IASTDeclaration`
Specified by:
  `copy` in interface `IASTNode`
Parameters:
  `style` - `IASTNode.CopyStyle` create a copy with or without locations. Please see `IASTNode.CopyStyle` for restrictions on copies with Locations.
Since:
  5.3

### getModifier

int getModifier()
Returns `STATIC`, `INLINE`, `EXTERN`, or `0`.

Since:
  5.2

### setModifier

void setModifier(int value)
Set the modifier value, not allowed on frozen ast.

Since:
  5.2